/*
 * 商品关键词库
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProductKeysController : BaseController
    {
        public ProductKeysController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商品关键词库列表

        /// <summary>
        /// 根据条件查询商品关键词库列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProductKeys data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询商品关键词库列表

        /// <summary>
        /// 商品关键词库列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProductKeys data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //关键词

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductKeys", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加商品关键词库

        /// <summary>
        /// 增加或修改商品关键词库信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加商品关键词库

        /// <summary>
        /// 增加或修改商品关键词库信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProductKeys data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Name", data.Name); //关键词
Fields.Add("ProductIds", data.ProductIds); //商品Id集合
Fields.Add("ColIds", data.ColIds); //分类Id集合

            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ProductKeys", Fields, 0);
            //AddSysLog(data.Id.ToString(), "ProductKeys", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改商品关键词库

        /// <summary>
        /// 增加或修改商品关键词库信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            ProductKeys editData = db.ProductKeys.FirstOrDefault() ?? new ProductKeys();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商品关键词库

        /// <summary>
        /// 增加或修改商品关键词库信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProductKeys data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Name", data.Name); //关键词
Fields.Add("ProductIds", data.ProductIds); //商品Id集合
Fields.Add("ColIds", data.ColIds); //分类Id集合

            //new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductKeys", Fields, data.Id);
            //AddSysLog(data.Id.ToString(),"ProductKeys","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除商品关键词库信息

        /// <summary>
        /// 删除商品关键词库信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProductKeys","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("ProductKeys", id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProductKeys","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductKeys", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProductKeys","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductKeys", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ProductKeys", Sort, Id);
            
            AddSysLog(Id.ToString(), "ProductKeys", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.ProductKeys.Add(new ProductKeys()
                {
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProductKeys", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProductKeys data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //关键词

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductKeys", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProductKeys", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
